﻿Option Strict On

Imports System.Drawing.Imaging
Imports System.Drawing.Text
Imports System.IO
Imports System.Reflection
Imports System.Runtime.InteropServices
Imports AForge
Imports AForge.Imaging
Imports AForge.Imaging.Filters

Public Class Form1

    Private Shared _lFontFamilies As New List(Of ListViewItem) 'List of Font-ListViewItems
    Private Shared _FontCollection As New InstalledFontCollection() 'Installierte Fonts
    Private Shared _string As String = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890äöüÄÖÜß"
    Private Shared fontDict As New Dictionary(Of FontFamily, Integer)

    Private Shared _lFontCharData As New List(Of _FontCharDATA)
    Private Shared _oFontCharData As _FontCharDATA



    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        MakeDoubleBuffered(lvFonts, True) 'Set ListView to DoubleBuffered
        _lFontFamilies = _getLVItems()
        lvFonts.Items.AddRange(_lFontFamilies.ToArray) 'ListView-Einträge setzen
    End Sub
    Private Sub Form1_Shown(sender As Object, e As EventArgs) Handles MyBase.Shown
        LV_SelectFocus(lvFonts, 0)
        Debug.WriteLine("ListView loaded:" & _lFontFamilies.Count)
    End Sub
    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        _getData()
    End Sub
    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        Dim img As System.Drawing.Image = Nothing

        _lFontCharData = DirectCast(DeserializeBinary(), List(Of _FontCharDATA))

        For Each _fcd As _FontCharDATA In _lFontCharData
            Debug.WriteLine("Fontname: " & _fcd._FontName & " - Character: " & _fcd._Character)

            'img = ByteArray2Image(_fcd._ByteDATA)
            'pb1.Image = img
            'pb1.Refresh()

            Dim _unmanagedImage = UnmanagedImage.FromManagedImage(New Bitmap(45, 45))
            For x As Integer = 0 To 44
                For y As Integer = 0 To 44
                    If _fcd._boolDATA(x, y) = True Then
                        _unmanagedImage.SetPixel(x, y, Color.White)
                    Else
                        _unmanagedImage.SetPixel(x, y, Color.Black)
                    End If
                Next
            Next
            pb2.Image = _unmanagedImage.ToManagedImage
            pb2.Refresh()

        Next
    End Sub



    Private Shared Sub _getData()
        Dim _fFont As Font = Nothing
        ' Dim _newRow As DataSet1.dtDatenRow = Nothing
        Dim _bmp As New Bitmap(45, 45)
        Dim _grey_bmp As UnmanagedImage
        Dim blobCounter As New BlobCounter()
        Dim rects() As Rectangle
        Dim _grey_Filter As New Grayscale(0.2125, 0.7154, 0.0721)
        Dim _invert_Filter As New Invert()
        Dim thresholdFilter As New Threshold(120)
        Dim _unmanagedImage As UnmanagedImage = Nothing
        Dim _blobs() As Blob
        Dim _active As New List(Of IntPoint)
        Dim _left As Integer = 45
        Dim _right As Integer = 0
        Dim _top As Integer = 45
        Dim _bottom As Integer = 0
        Dim _width As Integer = 0
        Dim _height As Integer = 0
        Dim _rect As Rectangle = Nothing

        Dim _mycolor As Color = Nothing
        Dim ret As Integer = 0
        Dim _colorDataArray(45, 45) As Boolean

        blobCounter.MinHeight = 1
        blobCounter.MinWidth = 1
        blobCounter.CoupledSizeFiltering = True
        blobCounter.FilterBlobs = True
        blobCounter.ObjectsOrder = ObjectsOrder.Size

        ' Each Font
        For Each _font As ListViewItem In Form1.lvFonts.Items
            ' Set new Font
            _fFont = New Font(_font.Text, 24, FontStyle.Regular)
            LV_SelectFocus(Form1.lvFonts, Form1.lvFonts.FindItemWithText(_fFont.Name).Index)
            For Each _chr As String In _string
                Application.DoEvents()
                ' draw Character on Bitmap
                _Graphics._draw(_bmp, _chr, _fFont)
                _grey_bmp = UnmanagedImage.FromManagedImage(_bmp)
                ' use Filters
                _unmanagedImage = UnmanagedImage.FromManagedImage(_grey_Filter.Apply(_bmp))
                thresholdFilter.ApplyInPlace(_unmanagedImage)
                _invert_Filter.ApplyInPlace(_unmanagedImage)
                blobCounter = New BlobCounter(_unmanagedImage)
                blobCounter.ProcessImage(_unmanagedImage)
                rects = blobCounter.GetObjectsRectangles()
                _blobs = blobCounter.GetObjectsInformation()
                _active = _unmanagedImage.CollectActivePixels()
                ' get enclosing Rectangle
                _left = 45
                _right = 0
                _top = 45
                _bottom = 0
                _width = 0
                _height = 0
                For Each _point As IntPoint In _active
                    If _point.X < _left Then
                        _left = _point.X
                    End If
                    If _point.X > _right Then
                        _right = _point.X
                    End If
                    If _point.Y < _top Then
                        _top = _point.Y
                    End If
                    If _point.Y > _bottom Then
                        _bottom = _point.Y
                    End If
                Next
                _rect = New Rectangle(_left - 1, _top - 1, (_right + 3) - _left, (_bottom + 3) - _top)
                ' get boolean Array
                Array.Clear(_colorDataArray, 0, _colorDataArray.Length)
                For x As Integer = 0 To _unmanagedImage.Width - 1
                    For y As Integer = 0 To _unmanagedImage.Height - 1
                        _mycolor = _unmanagedImage.GetPixel(x, y)
                        ' Transform RGB color space to Y (gray scale)
                        ret = CInt((_mycolor.R * 0.299 + _mycolor.G * 0.578 + _mycolor.B * 0.114))
                        If ret > 120 Then
                            _colorDataArray(x, y) = False
                            '_unmanagedImage.SetPixel(x, y, Color.White)
                        Else
                            _colorDataArray(x, y) = True
                            '_unmanagedImage.SetPixel(x, y, Color.Black)
                        End If
                    Next
                Next
                ' add new FontCharData entry to List
                ' _lFontCharData.Add(New _FontCharDATA(_fFont.Name, _chr, _rect, BmpToArray(_bmp), _colorDataArray))
                _lFontCharData.Add(New _FontCharDATA(_fFont.Name, _chr, _rect, _colorDataArray))
            Next
        Next
        ' Liste serialisieren
        SerializeBinary(_lFontCharData)
    End Sub

    Private Shared Sub LV_SelectFocus(ByVal ListView As ListView, ByVal Index As Integer, Optional ByVal RemoveSelection As Boolean = True)
        With ListView
            ' Plausibilitätsprüfungen
            If Index < 0 Then Index = 0
            If Index > .Items.Count - 1 Then Index = .Items.Count - 1
            ' ggf. vorher eine vorhandene Auswahl entfernen
            If RemoveSelection Then .SelectedItems.Clear()
            If Index < .Items.Count Then
                With .Items(Index)
                    ' Eintrag selektieren
                    .Selected = True
                    ' Sicherstellen, dass der Eintrag sich im 
                    ' sichtbaren Bereich des Controls befindet
                    .EnsureVisible()
                    ' Eintrag als aktiven Eintrag festlegen
                    .Focused = True
                End With
            End If
        End With
    End Sub

    Private Sub MakeDoubleBuffered(control As Control, setting As Boolean)
        Dim controlType As Type = control.[GetType]()
        Dim pi As PropertyInfo = controlType.GetProperty("DoubleBuffered", BindingFlags.Instance Or BindingFlags.NonPublic)
        pi.SetValue(control, setting, Nothing)
    End Sub

    Private Function _getLVItems() As List(Of ListViewItem)
        Dim _lItems As New List(Of ListViewItem)
        Dim tempFont As Font
        For Each _fontFamiliy As FontFamily In _FontCollection.Families
            Dim _it As New ListViewItem
            _it.Name = _fontFamiliy.Name
            _it.Text = _fontFamiliy.Name
            If _fontFamiliy.IsStyleAvailable(FontStyle.Regular) Then
                tempFont = New Font(_fontFamiliy, 10, FontStyle.Regular)
                _it.Font = tempFont
            ElseIf _fontFamiliy.IsStyleAvailable(FontStyle.Bold) Then
                tempFont = New Font(_fontFamiliy, 10, FontStyle.Bold)
                _it.Font = tempFont
            ElseIf _fontFamiliy.IsStyleAvailable(FontStyle.Italic) Then
                tempFont = New Font(_fontFamiliy, 10, FontStyle.Italic)
                _it.Font = tempFont
            End If
            _lItems.Add(_it)
        Next
        Return _lItems
    End Function

    Private Sub _lvChangeFont()
        If lvFonts.SelectedItems.Count > 0 Then
            Using _fnt As New Font(lvFonts.SelectedItems(0).Text, 24, FontStyle.Regular)
                _Graphics._actFont = _fnt
            End Using
        End If
    End Sub



    Private Shared Function SerializeBinary(ByVal obj As Object) As MemoryStream
        Dim serializer As New Runtime.Serialization.Formatters.Binary.BinaryFormatter
        Dim memStrm As New MemoryStream
        serializer.Serialize(memStrm, obj)
        Dim file As New FileStream("file.bin", FileMode.Create, FileAccess.Write)
        memStrm.WriteTo(file)
        file.Close()
        memStrm.Close()
        Return memStrm
    End Function
    Private Shared Function DeserializeBinary() As Object
        Dim file As New FileStream("file.bin", FileMode.Open, FileAccess.Read)
        Dim serializer As New Runtime.Serialization.Formatters.Binary.BinaryFormatter
        Dim obj As Object = serializer.Deserialize(file)
        file.Close()
        Return obj
    End Function
    Public Function Image2ByteArray(ByVal Bild As System.Drawing.Image, ByVal Bildformat As System.Drawing.Imaging.ImageFormat) As Byte()
        Dim MS As New IO.MemoryStream
        Bild.Save(MS, Bildformat)
        MS.Flush()
        Return MS.ToArray
    End Function
    Public Function ByteArray2Image(ByVal ByAr() As Byte) As System.Drawing.Image
        Dim img As System.Drawing.Image = Nothing
        Dim MS As New MemoryStream(ByAr)
        Try
            img = System.Drawing.Image.FromStream(MS)
        Catch ex As Exception
            Debug.WriteLine(ex.Message)
            Return Nothing
        End Try
        Return img
    End Function
    Public Shared Function BmpToArray(value As Bitmap) As [Byte]()
        Dim data As BitmapData = value.LockBits(New Rectangle(0, 0, value.Width, value.Height), ImageLockMode.[ReadOnly], value.PixelFormat)
        Try
            Dim ptr As IntPtr = data.Scan0
            Dim bytes As Integer = System.Math.Abs(data.Stride) * value.Height
            Dim rgbValues As Byte() = New Byte(bytes - 1) {}
            Marshal.Copy(ptr, rgbValues, 0, bytes)
            Return rgbValues
        Finally
            value.UnlockBits(data)
        End Try
    End Function



    <Serializable()>
    Public Class _FontCharDATA
        Private __font As String
        Private __char As String
        Private __enclosingRect As Rectangle
        Private __boolDats As Boolean(,)
        Private __byteData As Byte()
        Public Property _boolDATA As Boolean(,)
            Get
                Return __boolDats
            End Get
            Set(value As Boolean(,))
                __boolDats = value
            End Set
        End Property
        Public Property _ByteDATA As Byte()
            Get
                Return __byteData
            End Get
            Set(value As Byte())
                __byteData = value
            End Set
        End Property
        Public Property _FontName As String
            Get
                Return __font
            End Get
            Set(value As String)
                __font = value
            End Set
        End Property
        Public Property _Character As String
            Get
                Return __char
            End Get
            Set(value As String)
                __char = value
            End Set
        End Property
        Public Property _enclosingRect As Rectangle
            Get
                Return __enclosingRect
            End Get
            Set(value As Rectangle)
                __enclosingRect = value
            End Set
        End Property
        Public Sub New(ByVal _font As String, ByVal _char As String, ByVal _enclRECT As Rectangle, ByVal _bytedata As Byte(), ByVal _booldata As Boolean(,))
            __font = _font
            __char = _char
            __boolDats = _booldata
            __enclosingRect = _enclRECT
            __byteData = _bytedata
        End Sub
        Public Sub New(ByVal _font As String, ByVal _char As String, ByVal _enclRECT As Rectangle, ByVal _booldata As Boolean(,))
            __font = _font
            __char = _char
            __boolDats = _booldata
            __enclosingRect = _enclRECT
        End Sub
    End Class



End Class
