﻿Option Strict On
Imports System.Drawing.Drawing2D
Imports System.Drawing.Imaging
Imports System.Runtime.InteropServices

Public Class _Graphics
    Implements IDisposable
    Private Shared Property sf As New StringFormat
    Private Shared Property img As Bitmap
    Private Shared Property middlebox As Size
    Public Shared Function _draw(ByVal _pb1 As PictureBox, Optional _string As String = "", Optional _actFont As Font = Nothing) As Bitmap
        'PictureBox Ausrichtug mittig setzen
        sf.LineAlignment = StringAlignment.Center
        sf.Alignment = StringAlignment.Center
        img = New Bitmap(_pb1.Width, _pb1.Height, Imaging.PixelFormat.Format24bppRgb)
        middlebox = New Size(CInt(_pb1.Width / 2), CInt(_pb1.Height / 2))
        Using gr As Graphics = Graphics.FromImage(img)
            Try
                gr.Clear(_pb1.BackColor)
                If _string <> "" Then
                    gr.DrawString(_string, _actFont, Brushes.Black, middlebox.Width, middlebox.Height, sf)
                Else
                    gr.DrawString(_actChar, _actFont, Brushes.Black, middlebox.Width, middlebox.Height, sf)
                End If
                gr.Dispose()
            Catch ex As Exception
            End Try
        End Using
        Return img
    End Function
    Public Shared Function _draw(ByVal _bmp As Bitmap, Optional _string As String = "", Optional _actFont As Font = Nothing) As Bitmap
        'PictureBox Ausrichtug mittig setzen
        sf.LineAlignment = StringAlignment.Center
        sf.Alignment = StringAlignment.Center
        middlebox = New Size(CInt(_bmp.Width / 2), CInt(_bmp.Height / 2))
        Using gr As Graphics = Graphics.FromImage(_bmp)
            Try
                gr.Clear(Color.White)
                If _string <> "" Then
                    gr.DrawString(_string, _actFont, Brushes.Black, middlebox.Width, middlebox.Height, sf)
                Else
                    gr.DrawString(_actChar, _actFont, Brushes.Black, middlebox.Width, middlebox.Height, sf)
                End If
                gr.Dispose()
            Catch ex As Exception
            End Try
        End Using
        Return img
    End Function
    Public Shared Function _getRect(ByVal bmp As Bitmap) As Bitmap
        Dim _rect As Rectangle
        'Dim bmpScaled As Bitmap = New Bitmap(bmp.Width, bmp.Height, PixelFormat.Format32bppArgb)
        Dim bmpScaled As Bitmap = New Bitmap(120, 120, bmp.PixelFormat)
        Dim _lbBMP As New LockBits(bmp)
        _lbBMP.LockBits()
        Dim getLeftCrop As Func(Of Integer) = Function()
                                                  For x = 0 To _lbBMP.Bitmap.Width - 1
                                                      For y = 0 To _lbBMP.Bitmap.Height - 1
                                                          If _lbBMP.GetPixel(x, y).GetBrightness = 0 Then Return x
                                                      Next
                                                  Next
                                                  Return -1
                                              End Function
        Dim getRightCrop As Func(Of Integer) = Function()
                                                   For x = _lbBMP.Bitmap.Width - 1 To 0 Step -1
                                                       For y = 0 To _lbBMP.Bitmap.Height - 1
                                                           If _lbBMP.GetPixel(x, y).GetBrightness = 0 Then Return x
                                                       Next
                                                   Next
                                                   Return -1
                                               End Function
        Dim getTopCrop As Func(Of Integer) = Function()
                                                 For y = 0 To _lbBMP.Bitmap.Height - 1
                                                     For x = 0 To _lbBMP.Bitmap.Width - 1
                                                         If _lbBMP.GetPixel(x, y).GetBrightness = 0 Then Return y
                                                     Next
                                                 Next
                                                 Return -1
                                             End Function
        Dim getBottomCrop As Func(Of Integer) = Function()
                                                    For y = _lbBMP.Bitmap.Height - 1 To 0 Step -1
                                                        For x = 0 To _lbBMP.Bitmap.Width - 1
                                                            If _lbBMP.GetPixel(x, y).GetBrightness = 0 Then Return y
                                                        Next
                                                    Next
                                                    Return -1
                                                End Function
        Dim xCropLeft = getLeftCrop()
        Dim xCropRight = getRightCrop()
        Dim yCropTop = getTopCrop()
        Dim yCropBottom = getBottomCrop()
        _rect = New Rectangle(xCropLeft, yCropTop, xCropRight - xCropLeft + 1, yCropBottom - yCropTop + 1)

        Debug.WriteLine(_rect.ToString)
        _lbBMP.UnlockBits()
        _lbBMP.Dispose()
        Using grp = Graphics.FromImage(bmpScaled)
            grp.InterpolationMode = Drawing2D.InterpolationMode.NearestNeighbor
            grp.SmoothingMode = Drawing2D.SmoothingMode.HighSpeed
            grp.PixelOffsetMode = Drawing2D.PixelOffsetMode.HighSpeed
            grp.DrawImage(bmp, New Rectangle(0, 0, bmp.Width + 1, bmp.Height + 1), _rect, GraphicsUnit.Pixel)
            ' grp.DrawRectangle(New Pen(Color.Black), _rect)
        End Using
        Return bmpScaled
    End Function
    Private Shared ActChar As String
    Public Shared Property _actChar As String
        Get
            Return ActChar
        End Get
        Set(value As String)
            ActChar = value
        End Set
    End Property
    Private Shared ActFont As Font
    Public Shared Property _actFont As Font
        Get
            Return ActFont
        End Get
        Set(value As Font)
            ActFont = value
        End Set
    End Property
#Region "IDisposable Support"
    Private disposedValue As Boolean ' So ermitteln Sie überflüssige Aufrufe

    ' IDisposable
    Protected Overridable Sub Dispose(disposing As Boolean)
        If Not Me.disposedValue Then
            If disposing Then
                ' TODO: Verwalteten Zustand löschen (verwaltete Objekte).
            End If

            ' TODO: Nicht verwaltete Ressourcen (nicht verwaltete Objekte) freigeben und Finalize() unten überschreiben.
            ' TODO: Große Felder auf NULL festlegen.
        End If
        Me.disposedValue = True
    End Sub

    ' TODO: Finalize() nur überschreiben, wenn Dispose(ByVal disposing As Boolean) oben über Code zum Freigeben von nicht verwalteten Ressourcen verfügt.
    'Protected Overrides Sub Finalize()
    '    ' Ändern Sie diesen Code nicht. Fügen Sie oben in Dispose(ByVal disposing As Boolean) Bereinigungscode ein.
    '    Dispose(False)
    '    MyBase.Finalize()
    'End Sub

    ' Dieser Code wird von Visual Basic hinzugefügt, um das Dispose-Muster richtig zu implementieren.
    Public Sub Dispose() Implements IDisposable.Dispose
        ' Ändern Sie diesen Code nicht. Fügen Sie oben in Dispose(disposing As Boolean) Bereinigungscode ein.
        Dispose(True)
        GC.SuppressFinalize(Me)
    End Sub
#End Region
    Public Shared Function Image2Bool(ByVal img As Bitmap) As Boolean()()
        Dim bmp As New Bitmap(img)
        Dim s As Boolean()() = New Boolean(bmp.Height - 1)() {}
        Dim _lb As New LockBits(bmp)
        _lb.LockBits()
        For y As Integer = 0 To bmp.Height - 1
            s(y) = New Boolean(bmp.Width - 1) {}
            For x As Integer = 0 To bmp.Width - 1
                's(y)(x) = bmp.GetPixel(x, y).GetBrightness() < 0.3
                s(y)(x) = _lb.GetPixel(x, y).GetBrightness() < 0.7
            Next
        Next
        _lb.UnlockBits()
        Return s
    End Function
    Public Shared Function Bool2Image(ByVal _boolArray As Boolean()()) As Bitmap
        Dim bmp As New Bitmap(_boolArray(0).Length, _boolArray.Length)
        Dim _lb As New LockBits(bmp)
        Using g As Graphics = Graphics.FromImage(bmp)
            g.Clear(Color.White)
        End Using
        _lb.LockBits()
        For y As Integer = 0 To bmp.Height - 1
            For x As Integer = 0 To bmp.Width - 1
                If _boolArray(y)(x) Then
                    _lb.SetPixel(x, y, Color.Black)
                End If
            Next
        Next
        _lb.UnlockBits()
        Return bmp
    End Function
    Public Class ZhangSuen_Thinning
        Public Shared Function ZhangSuenThinning(s As Boolean()()) As Boolean()()
            Dim temp As Boolean()() = ArrayClone(s)
            ' make a deep copy to start.. 
            Dim count As Integer = 0
            Do
                ' the missing iteration
                count = [step](1, temp, s)
                temp = ArrayClone(s)
                ' ..and on each..
                count += [step](2, temp, s)
                ' ..call!
                temp = ArrayClone(s)
            Loop While count > 0

            Return s
        End Function
        Private Shared Function [step](stepNo As Integer, temp As Boolean()(), s As Boolean()()) As Integer
            Dim count As Integer = 0

            For a As Integer = 1 To temp.Length - 2
                For b As Integer = 1 To temp(0).Length - 2
                    If SuenThinningAlg(a, b, temp, stepNo = 2) Then
                        ' still changes happening?
                        If s(a)(b) Then
                            count += 1
                        End If
                        s(a)(b) = False
                    End If
                Next
            Next
            Return count
        End Function
        Private Shared Function SuenThinningAlg(x As Integer, y As Integer, s As Boolean()(), even As Boolean) As Boolean
            Dim p2 As Boolean = s(x)(y - 1)
            Dim p3 As Boolean = s(x + 1)(y - 1)
            Dim p4 As Boolean = s(x + 1)(y)
            Dim p5 As Boolean = s(x + 1)(y + 1)
            Dim p6 As Boolean = s(x)(y + 1)
            Dim p7 As Boolean = s(x - 1)(y + 1)
            Dim p8 As Boolean = s(x - 1)(y)
            Dim p9 As Boolean = s(x - 1)(y - 1)


            Dim bp1 As Integer = NumberOfNonZeroNeighbors(x, y, s)
            If bp1 >= 2 AndAlso bp1 <= 6 Then
                '2nd condition
                If NumberOfZeroToOneTransitionFromP9(x, y, s) = 1 Then
                    If even Then
                        If Not ((p2 AndAlso p4) AndAlso p8) Then
                            If Not ((p2 AndAlso p6) AndAlso p8) Then
                                Return True
                            End If
                        End If
                    Else
                        If Not ((p2 AndAlso p4) AndAlso p6) Then
                            If Not ((p4 AndAlso p6) AndAlso p8) Then
                                Return True
                            End If
                        End If
                    End If
                End If
            End If
            Return False
        End Function
        Private Shared Function NumberOfZeroToOneTransitionFromP9(x As Integer, y As Integer, s As Boolean()()) As Integer
            Dim p2 As Boolean = s(x)(y - 1)
            Dim p3 As Boolean = s(x + 1)(y - 1)
            Dim p4 As Boolean = s(x + 1)(y)
            Dim p5 As Boolean = s(x + 1)(y + 1)
            Dim p6 As Boolean = s(x)(y + 1)
            Dim p7 As Boolean = s(x - 1)(y + 1)
            Dim p8 As Boolean = s(x - 1)(y)
            Dim p9 As Boolean = s(x - 1)(y - 1)

            Dim A As Integer = Convert.ToInt32((Not p2 AndAlso p3)) + Convert.ToInt32((Not p3 AndAlso p4)) + Convert.ToInt32((Not p4 AndAlso p5)) + Convert.ToInt32((Not p5 AndAlso p6)) + Convert.ToInt32((Not p6 AndAlso p7)) + Convert.ToInt32((Not p7 AndAlso p8)) + Convert.ToInt32((Not p8 AndAlso p9)) + Convert.ToInt32((Not p9 AndAlso p2))
            Return A
        End Function
        Private Shared Function NumberOfNonZeroNeighbors(x As Integer, y As Integer, s As Boolean()()) As Integer
            Dim count As Integer = 0
            If s(x - 1)(y) Then
                count += 1
            End If
            If s(x - 1)(y + 1) Then
                count += 1
            End If
            If s(x - 1)(y - 1) Then
                count += 1
            End If
            If s(x)(y + 1) Then
                count += 1
            End If
            If s(x)(y - 1) Then
                count += 1
            End If
            If s(x + 1)(y) Then
                count += 1
            End If
            If s(x + 1)(y + 1) Then
                count += 1
            End If
            If s(x + 1)(y - 1) Then
                count += 1
            End If
            Return count
        End Function
        Private Shared Function ArrayClone(Of T)(A__1 As T()()) As T()()
            Return A__1.[Select](Function(a__2) a__2.ToArray()).ToArray()
        End Function
    End Class
    Public Shared Function ResizeImage(ByVal image As Bitmap, ByVal _size As Size, Optional ByVal preserveAspectRatio As Boolean = True) As Bitmap
        Dim newWidth As Integer
        Dim newHeight As Integer
        If preserveAspectRatio Then
            Dim originalWidth As Integer = image.Width
            Dim originalHeight As Integer = image.Height
            Dim percentWidth As Single = CSng(_size.Width) / CSng(originalWidth)
            Dim percentHeight As Single = CSng(_size.Height) / CSng(originalHeight)
            Dim percent As Single = If(percentHeight < percentWidth, percentHeight, percentWidth)
            newWidth = CInt(45 * percent + _size.Width)
            newHeight = CInt(45 * percent + _size.Height)

            Debug.WriteLine(percentWidth & " * " & percentHeight)
        Else
            newWidth = _size.Width
            newHeight = _size.Height
        End If
        Dim newImage As Bitmap = New Bitmap(newWidth, newHeight)
        Using graphicsHandle As Graphics = Graphics.FromImage(newImage)
            graphicsHandle.InterpolationMode = InterpolationMode.HighQualityBicubic
            graphicsHandle.DrawImage(image, 0, 0, newWidth, newHeight)
        End Using
        Return newImage
    End Function
    Public Class BoundingRECT
        Public Shared Function _einschlRechteck(ByVal _source As Bitmap) As Bitmap
            Dim _lockBits_A As LockBits = New LockBits(_source)
            Dim _lockBits_B As LockBits = New LockBits(New Bitmap(_source.Width, _source.Height))
            Dim _minX As Integer = _source.Width
            Dim _maxX As Integer = 0
            Dim _minY As Integer = _source.Height
            Dim _maxY As Integer = 0
            Dim _width As Integer = 0
            Dim _height As Integer = 0
            _lockBits_A.LockBits()
            _lockBits_B.LockBits()
            For x = 0 To _source.Width - 1 ' links nach rechts
                For y = 0 To _source.Height - 1 'oben nach unten
                    Dim _nCol As Color = _lockBits_A.GetPixel(x, y)
                    'If _nCol.R <> 255 AndAlso _nCol.G <> 255 AndAlso _nCol.B <> 255 Then
                    If _nCol.R = 0 AndAlso _nCol.G = 0 AndAlso _nCol.B = 0 Then
                        'Einschliessendes Rechteck finden
                        If y < _minY Then
                            _minY = y
                        End If
                        If y > _maxY Then
                            _maxY = y
                        End If
                        If x < _minX Then
                            _minX = x
                        End If
                        If x > _maxX Then
                            _maxX = x
                        End If
                    End If
                    _lockBits_B.SetPixel(x, y, _nCol)
                Next
            Next
            _lockBits_A.UnlockBits()
            _lockBits_B.UnlockBits()
            Return _lockBits_B.Bitmap
        End Function

        Public Shared Function _Rechteck(ByVal _source As Bitmap) As Rectangle
            Dim _lockBits_A As LockBits = New LockBits(_source)
            Dim _lockBits_B As LockBits = New LockBits(New Bitmap(_source.Width, _source.Height))
            Dim _minX As Integer = _source.Width
            Dim _maxX As Integer = 0
            Dim _minY As Integer = _source.Height
            Dim _maxY As Integer = 0
            Dim _width As Integer = 0
            Dim _height As Integer = 0
            _lockBits_A.LockBits()
            _lockBits_B.LockBits()
            For x = 0 To _source.Width - 1 ' links nach rechts
                For y = 0 To _source.Height - 1 'oben nach unten
                    Dim _nCol As Color = _lockBits_A.GetPixel(x, y)
                    'If _nCol.R <> 255 AndAlso _nCol.G <> 255 AndAlso _nCol.B <> 255 Then
                    If _nCol.R = 0 AndAlso _nCol.G = 0 AndAlso _nCol.B = 0 Then
                        'Einschliessendes Rechteck finden
                        If y < _minY Then
                            _minY = y
                        End If
                        If y > _maxY Then
                            _maxY = y
                        End If
                        If x < _minX Then
                            _minX = x
                        End If
                        If x > _maxX Then
                            _maxX = x
                        End If
                    End If
                    _lockBits_B.SetPixel(x, y, _nCol)
                Next
            Next
            _lockBits_A.UnlockBits()
            _lockBits_B.UnlockBits()

            _lockBits_A.Dispose()
            _lockBits_B.Dispose()

            Return New Rectangle(_minX, _minY, _maxX - _minX, _maxY - _minY)
        End Function

        Private Shared _rect As Rectangle = Nothing
        Private Shared _minX As Integer = 0
        Private Shared _maxX As Integer = 0
        Private Shared _minY As Integer = 0
        Private Shared _maxY As Integer = 0
        Private Shared _width As Integer = 0
        Private Shared _height As Integer = 0
        Private Shared _nCol As Color = Nothing

        Public Shared Function _Rechteck(ByVal _source As LockBits) As Rectangle
            _minX = _source.Width
            _maxX = 0
            _minY = _source.Height
            _maxY = 0
            _width = 0
            _height = 0
            For x = 0 To _source.Width - 1 ' links nach rechts
                For y = 0 To _source.Height - 1 'oben nach unten
                    _nCol = _source.GetPixel(x, y)
                    'If _nCol.R <> 255 AndAlso _nCol.G <> 255 AndAlso _nCol.B <> 255 Then
                    If _nCol.R = 0 AndAlso _nCol.G = 0 AndAlso _nCol.B = 0 Then
                        'Einschliessendes Rechteck finden
                        If y < _minY Then
                            _minY = y
                        End If
                        If y > _maxY Then
                            _maxY = y
                        End If
                        If x < _minX Then
                            _minX = x
                        End If
                        If x > _maxX Then
                            _maxX = x
                        End If
                    End If
                Next
            Next
            _rect.X = _minX
            _rect.Y = _minY
            _rect.Width = _maxX - _minX
            _rect.Height = _maxY - _minY
            Return _rect
        End Function
    End Class



    Public Shared Function _binarizeBMP(ByRef _bmp As Bitmap) As Bitmap
        Dim _lockBTS As New LockBits(_bmp)
        _lockBTS.LockBits()
        ' The height of the image.
        For y As Integer = 0 To _lockBTS.Height - 1
            ' The width of the image.
            For x = 0 To _lockBTS.Width - 1
                ' Get the pixel from current bitmap object.
                Dim curPixColor As Color = _lockBTS.GetPixel(x, y)
                ' This is a gray variable.
                Dim ret As Integer
                ' Transform RGB color space to Y (gray scale)
                ret = CInt((curPixColor.R * 0.299 + curPixColor.G * 0.578 + curPixColor.B * 0.114))
                ' This is our threshold, you can change it.
                If ret > 120 Then
                    _lockBTS.SetPixel(x, y, Color.White)
                Else
                    _lockBTS.SetPixel(x, y, Color.Black)
                End If
                ' The closing 'The width of the image'.
            Next
            ' The closing 'The height of the image'.
        Next
        _lockBTS.UnlockBits()
        _lockBTS.Dispose()
        Return _bmp
    End Function


End Class
